@MISC{ebpf,
key = {{ebpf}},
title = {{eBPF (extened Binary Packet Filter)}},
note = {
\url{http://prototype-kernel.readthedocs.io/en/latest/bpf/}
},
language = {english},
}

@MISC{tofino,
	key = {{Tofino}},
	title = {{Barefoot Tofino}},
	note = {
	\url{https://barefootnetworks.com/products/brief-tofino/}
	},
	language = {english},
}

@MISC{cumulus,
	key = {{Cumulus Network}},
	title = {{Cumulus Network}},
	note = {
	\url{https://cumulusnetworks.com/}
	},
	language = {english},
}

@MISC{xplaint,
	key = {{xplaint}},
	title = {{Cavium XPliant}},
	note = {
	\url{http://www.cavium.com/pdfFiles/CNX880XX_PB_Rev1.pdf}
	},
	language = {english},
}

@MISC{Jericho2,
	key = {{Jericho2}},
	title = {{Brodcom Jericho2}},
	note = {
	\url{https://www.broadcom.com/news/product-releases/broadcom-ships-jericho2}
	},
	language = {english},
}

@MISC{ripe,
key = {{RIPE Network Coordination Centre}},
title = {{RIPE Network Coordination Centre}},
note = {
\url{https://www.ripe.net/}
},
language = {english},
}

@MISC{routeviews,
key = {{Route Views Project}},
title = {{Route Views Project}},
note = {
\url{http://www.routeviews.org/routeviews/}
},
language = {english},
}

@MISC{caida,
key = {{CAIDA Anonymized Internet Trace}},
title = {{CAIDA Anonymized Internet Trace}},
note = {
\url{https://www.caida.org}
},
language = {english},
}

@MISC{bgpreport,
key = {{BGP Report}},
title = {{BGP Report}},
note = {
\url{http://bgp.potaroo.net/}
},
language = {english},
}

@MISC{x86instructions,
key = {{x86 Instruction Set Reference}},
title = {{x86 Instruction Set Reference}},
note = {
\url{https://c9x.me/x86/}
},
language = {english},
}

@inproceedings{vanjacobson,
author = "Van Jacobson and Michael J. Karels",
title = "Congestion Avoidance and Control",
booktitle = "SIGCOMM 1988",
address = "Stanford, CA",
month = aug,
year = 1988
}

@inproceedings{yang2014guarantee,
title={{Guarantee IP lookup performance with FIB explosion}},
author={Yang, Tong and Xie, Gaogang and Li, YanBiao and Fu, Qiaobin and Liu, Alex X and Li, Qi and Mathy, Laurent},
booktitle={ACM SIGCOMM 2014},
}

@inproceedings{asai2015poptrie,
title={{Poptrie: A compressed trie with population count for fast and scalable software IP routing table lookup}},
author={Asai, Hirochika and Ohara, Yasuhiro},
booktitle={ACM SIGCOMM 2015},
} 

@article{nilsson1999ip,
title={{IP-address lookup using LC-tries}},
author={Nilsson, Stefan and Karlsson, Gunnar},
journal={IEEE Journal on selected Areas in Communications},
volume={17},
number={6},
pages={1083--1092},
year={1999},
}

@inproceedings{gallenmuller2015comparison,
title={{Comparison of frameworks for high-performance packet IO}},
author={Gallenm{\"u}ller, Sebastian and Emmerich, Paul and Wohlfart, Florian and Raumer, Daniel and Carle, Georg},
booktitle={ACM/IEEE ANCS},
year={2015}
}


@article{eatherton2004tree,
title={{Tree bitmap: hardware/software IP lookups with incremental updates}},
author={Eatherton, Will and Varghese, George and Dittia, Zubin},
journal={ACM SIGCOMM},
volume={34},
number={2},
pages={97--122},
year={2004},
}

@inproceedings{gupta1998routing,
title={Routing lookups in hardware at memory access speeds},
author={Gupta, Pankaj and Lin, Steven and McKeown, Nick},
booktitle={IEEE INFOCOM},
volume={3},
pages={1240--1247},
year={1998}
}

@inproceedings{zhou2013scalable,
title={{Scalable, high performance ethernet forwarding with CuckooSwitch}},
author={Zhou, Dong and Fan, Bin and Lim, Hyeontaek and Kaminsky, Michael and Andersen, David G},
booktitle=ACM CoNEXT},
pages={97--108},
year={2013}
}


@inproceedings{fu2006performance,
title={{Performance evaluation and cache behavior of LC-trie for IP-address lookup}},
author={Fu, Jing and Hagsand, Olof and Karlsson, Gunnar},
booktitle={IEEE Workshop on High Performance Switching and Routing},
pages={7--pp},
year={2006},
}

@article{zec2012dxr,
title={{DXR: towards a billion routing lookups per second in software}},
author={Zec, Marko and Rizzo, Luigi and Mikuc, Miljenko},
journal={ACM SIGCOMM Computer Communication Review},
volume={42},
number={5},
pages={29--36},
year={2012},
}

@inproceedings{retvari2013compressing,
title={{Compressing IP forwarding tables: towards entropy bounds and beyond}},
author={R{\'e}tv{\'a}ri, G{\'a}bor and Tapolcai, J{\'a}nos and K{\H{o}}r{\"o}si, Attila and Majd{\'a}n, Andr{\'a}s and Heszberger, Zal{\'a}n},
booktitle={ACM SIGCOMM Computer Communication Review},
volume={43},
number={4},
pages={111--122},
year={2013}
}


@article{degermark1997small,
title={Small forwarding tables for fast routing lookups},
author={Degermark, Mikael and Brodnik, Andrej and Carlsson, Svante and Pink, Stephen},
journal={ACM SIGCOMM},
volume={27},
number={4},
year={1997}
}


@inproceedings{pongracz2013cheap,
title={{Cheap silicon: a myth or reality? picking the right data plane hardware for software defined networking}},
author={Pongr{\'a}cz, Gergely and Moln{\'a}r, L{\'a}szl{\'o} and Kis, Zolt{\'a}n Lajos and Tur{\'a}nyi, Zolt{\'a}n},
booktitle={ACM SIGCOMM workshop on Hot topics in Software Defined Networking},
pages={103--108},
year={2013},
}


@MISC{dpdk,
key = {{dpdk}},
title = {{Data Plane Development Kit (DPDK)}},
note = {
\url{http://dpdk.org/}
},
language = {english},
} 

@MISC{fibbackbone,
key = {{Routing tables of backbone routers}},
title = {{Routing tables of backbone routers}},
note = {
\url{https://github.com/tamimcse/parse-bgpdump/}
},
language = {english},
}


@MISC{sailpatch,
key = {{SAIL-BM implementation in Linux kernel}},
title = {{SAIL-BM implementation in Linux kernel (patch)}},
note = {
\url{https://github.com/tamimcse/kernel-patches/blob/master/xdp-sail.patch/}
},
language = {english},
}

@MISC{saillpatch,
key = {{SAIL-L implementation in Linux kernel}},
title = {{SAIL-L implementation in Linux kernel (patch)}},
note = {
\url{https://github.com/tamimcse/kernel-patches/blob/master/sail-l.patch/}
},
language = {english},
}

@MISC{saildomino,
key = {{Implementation of SAIL-BM using Domino}},
title = {{Implementation of SAIL-BM using Domino}},
note = {
\url{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-bm.c}
}

@MISC{sailldomino,
key = {{Implementation of SAIL-L using Domino}},
title = {{Implementation of SAIL-L using Domino}},
note = {
\url{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-l.c}
}

@MISC{sailpipiline,
key = {{SAIL-BM Pipeline}},
title = {{SAIL-BM Pipeline}},
note = {
\url{https://raw.githubusercontent.com/tamimcse/domino-examples/master/pipeline-sail-bm.png},
}

@MISC{vpp,
key = {{vpp}},
title = {{Vector Packet Processing (VPP)}},
note = {
\url{https://wiki.fd.io/view/VPP}
},
language = {english},
}


@MISC{odp,
key = {{odp}},
title = {{OpenDataPlane(ODP)}},
note = {
\url{https://www.opendataplane.org/}
},
language = {english},
} 

@MISC{xdp,
key = {{XDP}},
title = {{XDP (eXpress Data path)}},
note = {
\url{http://prototype-kernel.readthedocs.io/en/latest/networking/XDP/introduction.html}
},
language = {english},
}

@inproceedings{hoiland2018express,
title={{The eXpress Data Path: Fast Programmable Packet Processing in the Operating System Kernel}},
author={H{\o}iland-J{\o}rgensen, Toke and Brouer, Jesper Dangaard and Borkmann, Daniel and Fastabend, John and Herbert, Tom and Ahern, David and Miller, David},
booktitle={ACM CoNEXT},
year={2018},
}


@book{warren2013hacker,
title={{Hacker's delight}},
author={Warren, Henry S},
year={2013},
publisher={Pearson Education}
}

@article{fog2011instruction,
title={{Instruction tables: Lists of instruction latencies, throughputs and micro-operation breakdowns for Intel, AMD and VIA CPUs}},
author={Fog, Agner and others},
journal={Copenhagen University College of Engineering},
volume={97},
pages={114},
year={2011}
}
  

@article{guide2011intel,
title={{Intel{\textregistered} 64 and IA-32 Architectures Software Developer’s Manual}},
author={Guide, Part},
journal={Volume 3B: System programming Guide, Part},
volume={2},
year={2011}
}

@inproceedings{keutzer2002asic,
title={From ASIC to ASIP: The next design discontinuity},
author={Keutzer, Kurt and Malik, Sharad and Newton, A Richard},
booktitle={IEEE International Conference on Computer Design: VLSI in Computers and Processors},
pages={84--90},
year={2002}
}

@inproceedings{sivaraman2016packet,
title={{Packet transactions: High-level programming for line-rate switches}},
author={Sivaraman, Anirudh and Cheung, Alvin and Budiu, Mihai and Kim, Changhoon and Alizadeh, Mohammad and Balakrishnan, Hari and Varghese, George and McKeown, Nick and Licking, Steve},
booktitle={ACM SIGCOMM},
pages={15--28},
year={2016}
}

@article{bosshart2013forwarding,
title={{Forwarding metamorphosis: Fast programmable match-action processing in hardware for SDN}},
author={Bosshart, Pat and Gibb, Glen and Kim, Hun-Seok and Varghese, George and McKeown, Nick and Izzard, Martin and Mujica, Fernando and Horowitz, Mark},
journal={ACM SIGCOMM},
volume={43},
number={4},
pages={99--110},
year={2013}
}

@inproceedings{tamimsail,
title={{SAIL Based FIB Lookup in a Programmable Pipeline Based Linux Router}},
author={Islam, Md Iftakharul and Khan, Javed I},
booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
year={2019}
}

@inproceedings{tamimrcp,
title={{Leveraging Domino to Implement RCP in a Stateful Programmable Pipeline}},
author={Islam, Md Iftakharul and Khan, Javed I},
booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
year={2019}
}

@inproceedings{narayana2017language,
title={Language-directed hardware design for network performance monitoring},
author={Narayana, Srinivas and Sivaraman, Anirudh and Nathan, Vikram and Goyal, Prateesh and Arun, Venkat and Alizadeh, Mohammad and Jeyakumar, Vimalkumar and Kim, Changhoon},
booktitle={ACM SIGCOMM},
pages={85--98},
year={2017}
}
